/**
 * hypertimer.js
 * https://github.com/enmasseio/hypertimer
 *
 * A timer running faster or slower than real-time, and in continuous or
 * discrete time.
 *
 * @version 1.1.0
 * @date    2014-07-22
 *
 * @license
 * Copyright (C) 2014 Almende B.V., http://almende.com
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy
 * of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):"object"==typeof exports?exports.hypertimer=t():e.hypertimer=t()}(this,function(){return function(e){function t(r){if(n[r])return n[r].exports;var i=n[r]={exports:{},id:r,loaded:!1};return e[r].call(i.exports,i,i.exports,t),i.loaded=!0,i.exports}var n={};return t.m=e,t.c=n,t.p="",t(0)}([function(e,t,n){e.exports=n(1)},function(e,t,n){function r(e){function t(e){if(p.length>0){for(var t=p.length-1;t>=0&&p[t].time>e.time;)t--;p.splice(t+1,0,e)}else p.push(e)}function n(e,n){function r(){e.type===o.INTERVAL&&d[e.id]&&(e.occurrence++,e.time=e.firstTime+e.occurrence*e.interval,t(e)),delete d[e.id],"function"==typeof n&&n()}d[e.id]=e;try{0==e.callback.length?(e.callback(),r()):e.callback(r)}catch(i){r()}}function r(e){for(var t=0;t<p.length&&(p[t].time<=e||!isFinite(p[t].time));)t++;var n=p.splice(0,t);return 0==f&&i.shuffle(n),n}function a(){function e(){function e(){var r=t.shift();r?n(r,e):a()}c===u&&(m=i);var t=r(i);c===u?e():(t.forEach(n),a())}if(!(c===u&&Object.keys(d).length>0)){var t=p[0];if(v&&(clearTimeout(v),v=null),l&&t){var i=t.time,o=i-b.now(),f=c===u?0:o/c;v=setTimeout(e,f)}}}var c=1,f=!0,l=!1,s=null,m=null,p=[],d={},v=null,T=0,b={};return b.config=function(e){if(e){if("rate"in e){var t=e.rate===u?u:Number(e.rate);if(t!==u&&(isNaN(t)||0>=t))throw new TypeError('rate must be a positive number or the string "discrete"');m=b.now(),s=i.nowReal(),c=t}"deterministic"in e&&(f=e.deterministic?!0:!1)}return a(),{rate:c,deterministic:f}},b.setTime=function(e){if(e instanceof Date)m=e.valueOf();else{var t=Number(e);if(isNaN(t))throw new TypeError("time must be a Date or number");m=t}a()},b.now=function(){if(c===u)return m;if(l){var e=i.nowReal()-s,t=e*c;return m+t}return m},b["continue"]=function(){s=i.nowReal(),l=!0,a()},b.pause=function(){m=b.now(),s=null,l=!1,a()},b.getTime=function(){return new Date(b.now())},b.valueOf=b.getTime,b.toString=function(){return b.getTime().toString()},b.setTimeout=function(e,n){var r=T++,i=b.now()+n;if(isNaN(i))throw new TypeError("delay must be a number");return t({id:r,type:o.TIMEOUT,time:i,callback:e}),a(),r},b.setTrigger=function(e,n){var r=T++,i=Number(n);if(isNaN(i))throw new TypeError("time must be a Date or number");return t({id:r,type:o.TRIGGER,time:i,callback:e}),a(),r},b.setInterval=function(e,n,r){var i=T++,u=Number(n);if(isNaN(u))throw new TypeError("interval must be a number");(0>u||!isFinite(u))&&(u=0);var c;if(void 0!=r){if(c=Number(r),isNaN(c))throw new TypeError("firstTime must be a Date or number")}else c=b.now()+u;return t({id:i,type:o.INTERVAL,interval:u,time:c,firstTime:c,occurrence:0,callback:e}),a(),i},b.clearTimeout=function(e){if(d[e])return void delete d[e];for(var t=0;t<p.length;t++)if(p[t].id===e){p.splice(t,1),a();break}},b.clearTrigger=b.clearTimeout,b.clearInterval=b.clearTimeout,b.list=function(){return p.map(function(e){return e.id})},b.clear=function(){d={},p=[],a()},Object.defineProperty(b,"running",{get:function(){return l}}),b.config(e),b.setTime(i.nowReal()),b.continue(),b}var i=n(2),o={TIMEOUT:0,INTERVAL:1,TRIGGER:2},u="discrete";e.exports=r},function(e,t){t.nowReal="function"==typeof Date.now?function(){return Date.now()}:function(){return(new Date).valueOf()},t.shuffle=function(e){for(var t,n,r=e.length;r;t=Math.floor(Math.random()*r),n=e[--r],e[r]=e[t],e[t]=n);return e}}])});
//# sourceMappingURL=hypertimer.map